Hide navigation sidebar
Hide table of contents sidebar
Skip to content
Back to top
View this page
Toggle table of contents sidebar

# Internal modules

## `_binary` module

Binary input/output support routines.

PIL._binary.i16be(c: bytes, o: int = 0) → int

PIL._binary.i16le(c: bytes, o: int = 0) → int

  Converts a 2-bytes (16 bits) string to an unsigned integer.

  Parameters:

    - c – string containing bytes to convert

    - o – offset of bytes to convert in string

PIL._binary.i32be(c: bytes, o: int = 0) → int

PIL._binary.i32le(c: bytes, o: int = 0) → int

  Converts a 4-bytes (32 bits) string to an unsigned integer.

  Parameters:

    - c – string containing bytes to convert

    - o – offset of bytes to convert in string

PIL._binary.i8(c: bytes) → int

PIL._binary.o16be(i: int) → bytes

PIL._binary.o16le(i: int) → bytes

PIL._binary.o32be(i: int) → bytes

PIL._binary.o32le(i: int) → bytes

PIL._binary.o8(i: int) → bytes

PIL._binary.si16be(c: bytes, o: int = 0) → int

  Converts a 2-bytes (16 bits) string to a signed integer, big endian.

  Parameters:

    - c – string containing bytes to convert

    - o – offset of bytes to convert in string

PIL._binary.si16le(c: bytes, o: int = 0) → int

  Converts a 2-bytes (16 bits) string to a signed integer.

  Parameters:

    - c – string containing bytes to convert

    - o – offset of bytes to convert in string

PIL._binary.si32be(c: bytes, o: int = 0) → int

  Converts a 4-bytes (32 bits) string to a signed integer, big endian.

  Parameters:

    - c – string containing bytes to convert

    - o – offset of bytes to convert in string

PIL._binary.si32le(c: bytes, o: int = 0) → int

  Converts a 4-bytes (32 bits) string to a signed integer.

  Parameters:

    - c – string containing bytes to convert

    - o – offset of bytes to convert in string

## `_deprecate` module

PIL._deprecate.deprecate(deprecated: str, when: int | None, replacement: str | None = None, *, action: str | None = None, plural: bool = False, stacklevel: int = 3) → None

  Deprecations helper.

  Parameters:

    - deprecated – Name of thing to be deprecated.

    - when – Pillow major version to be removed in.

    - replacement – Name of replacement.

    - action – Instead of “replacement”, give a custom call to action e.g. “Upgrade to new thing”.

    - plural – if the deprecated thing is plural, needing “are” instead of “is”.

  Usually of the form:

  > “[deprecated] is deprecated and will be removed in Pillow [when] (yyyy-mm-dd). Use [replacement] instead.”

  You can leave out the replacement sentence:

  > “[deprecated] is deprecated and will be removed in Pillow [when] (yyyy-mm-dd)”

  Or with another call to action:

  > “[deprecated] is deprecated and will be removed in Pillow [when] (yyyy-mm-dd). [action].”

## `_tkinter_finder` module

Find compiled module linking to Tcl / Tk libraries

## `_typing` module

Provides a convenient way to import type hints that are not available on some Python versions.

class PIL._typing.Buffer

  Typing alias.

class PIL._typing.IntegralLike

  Typing alias.

class PIL._typing.NumpyArray

  Typing alias.

class PIL._typing.StrOrBytesPath

  Typing alias.

class PIL._typing.SupportsRead

  An object that supports the read method.

PIL._typing.TypeGuard = typing.TypeGuard

  See `typing.TypeGuard`.

## `_util` module

class PIL._util.DeferredError(ex: BaseException)

  Bases: `object`

  static new(ex: BaseException) → Any

    Creates an object that raises the wrapped exception `ex` when used, and casts it to `Any` type.

PIL._util.is_path(f: Any) → TypeGuard[str | bytes | PathLike[str] | PathLike[bytes]]

## `_version` module

PIL._version.__version__: str

  This is the master version number for Pillow, all other uses reference this module.

## `PIL.Image.core` module

An internal interface module previously known as `_imaging`, implemented in `_imaging.c`.

class PIL.Image.core.ImagingCore

  A representation of the image data.